
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Varnish简介 / 憋错料</title>

    <meta name="description" content="Varnish简介 Varnish介绍: Varnish是一个反向HTTP代理,有时也被称为HTTP的加速器或网络加速器:它存在于真实服务器的前面(可能有多级代理),将来自于客户端的请求中的部分内容存储在自身的内存中,以减少服务器响应时间和网络带宽消耗.与Varnish类似的开源解决方案还有squid. Varnish不仅仅是一个通过缓存数据加速服务的反向代理,根据其安装和配置,也可用来: web application firewall, DDoS attack defender,抵御DDos攻击 hotlink">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Varnish简介</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Varnish介绍：</p>
<p>　　<strong>Varnish</strong>是一个反向HTTP代理，有时也被称为HTTP的加速器或网络加速器；它存在于真实服务器的前面(可能有多级代理)，将来自于客户端的请求中的部分内容存储在自身的内存中，以减少服务器响应时间和网络带宽消耗。与Varnish类似的开源解决方案还有squid.</p>
<p>　　Varnish不仅仅是一个通过缓存数据加速服务的反向代理，根据其安装和配置，也可用来：</p>
<ul>
<li>web application firewall,</li>
<li>DDoS attack defender,抵御DDos攻击</li>
<li>hotlinking protector,链保护</li>
<li>load balancer,</li>
<li>integration point, 集成点</li>
<li>single sign-on gateway,单点登录网关</li>
<li>authentication and authorization policy mechanism,认证授权策略机制</li>
<li>quick fix for unstable backends, 不稳定后台的快速修复</li>
<li>HTTP router.</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwNDE3NDIvMjAxNzAxLzEwNDE3NDItMjAxNzAxMDExMTA4NTMzMzYtMTUxODk5NzQ2MC5wbmc=.jpg"></p>
<p><strong>Manager Process</strong>:</p>
<p>　　Manager Process是主模块，包含了Varnish的一些二进制程序。管理器进程的任务是将任务（包括缓存）委托给子进程。管理程序确保每个任务总是有一个进程。</p>
<p>　　Manager Process的CLI(命令行接口)可通过两种方式进行管理：</p>
<p>　　　　①varnishadm:一个基于列表的管理命令程序，其与varnishd守护进程相连接。</p>
<p>　　　　②VAC--&gt;vagent2：VAC(Varnish Administration Console)包括一个GUI和API，VAC是生产环境中最常用的实时图和统计数据工具，帮助确定Varnish缓存服务器的瓶颈和问题。VAC是一种varnish的缓存服务器组的管理控制台，也被称为高速缓存组。</p>
<p>缓存组是具有相同配置的varnish缓存服务器的集合。</p>
<p><strong>Cacher Process</strong>:</p>
<ul>
<li>listen to client requests</li>
<li>manage worker threads</li>
<li>store caches</li>
<li>log traffic</li>
<li>update counters for statistics 更新统计计数器</li>
</ul>
<p><strong>Shared Memory Log</strong>:　</p>
<p>　　varnish通过可以基于文件系统接口进行访问的共享内存区域来记录日志(shared memory log);默认是90MB；分为两部分：</p>
<p>　　　　前半部分是计数器；后半部分是客户端请求的数据；</p>
<p>要向使用Varnish,必须要配置好Varnish,而配置其前提是要先了解VCL(Varnish Configuration Language)。</p>
<p>VCL:是一种特殊的域语言用来描述Varnish缓存的请求处理和文件缓存策略的。</p>
<p>When a new configuration is loaded, the VCC process, created by the Manager process, translates the VCL code to C. This C code is compiled typically by gcc to a shared object. The shared object is then loaded into the cacher process.</p>
<p>　　当一个新的配置项被装载时，由管理进程创建出一个VCC进程，将VCL编译成C代码；之后C代码又被gcc编译器根据类型解释成一个共享对象，此对象接下来会被装入缓存进程中。</p>
<p>　　然而，VCL的工作流程被看作一个有限状态机</p>
<h2>Varnish&nbsp;Finite State Machine</h2>
<p>　　vcl_recv</p>
<p>　　vcl_hash:</p>
<p>　　　　vcl_hit</p>
<p>　　　　vcl_miss</p>
<p>　　　　vcl_purge</p>
<p>　　　　vcl_pipe</p>
<p>　　　　vcl_pass:</p>
<p>　　　　　　pass</p>
<p>　　　　　　hit_for_pass</p>
<p>　　vcl_backend_fetch</p>
<p>　　vcl_backend_response</p>
<p>　　vcl_backend_error</p>
<p>　　vcl_deliver</p>
<p>　　vcl_synth</p>
<pre>vcl的语法：
            (1)//,#,/*...*/：注释
            (2)sub $name:定义子例程
            (3)不支持循环，但支持条件判断
            (4)有内建变量
            (5)使用终止语句return,没有返回值
            (6)操作符：=，==，!=，~，&amp;&amp;，||</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwNDE3NDIvMjAxNzAxLzEwNDE3NDItMjAxNzAxMDExMjMwNTM3MTEtMTUyNjUyNjM3OS5wbmc=.jpg"></p>
<hr>
<br />应用实例：　</p>
<pre>/*测试缓存命中与否*/
sub vcl_deliver{
    if(obj.hits&gt;0){
    set resp.http.X-cache = "HIT via" + " " + server.ip;
    }
    else{
        set resp.http.X-cache = "MISS via" + " " + server.ip;
    }
}
/*强制对某些资源的请求不检查缓存*/
sub vcl_resv{
    if(req.url ~ "(?i)^/login" || req.url ~ "(?i)^/admin"){
    return(pass);
    }
}
/*对特定类型的资源，如公开的图片等，取消其私有标识，并强行设定其可以由varnish缓存的时长；*/
sub vcl_backend_response{
    if(beresp.http.cache-control !~ "s-maxage"){
        if(beresp.url ~ "(?i)\.jpg$"){
        set beresp.ttl = 7200s;
        unset beresp.http.Set-Cookie;
      }
    if(bereps.url ~ "(?i)\.css"){
        set bereps.ttl = 3600;
        unset beresp.http.Set-Cookie;
      }
    }
}    </pre>
<p>设置多个后端主机：</p>
<pre>backend default{
    .host = "172.18.100.67";
    .port = "80";
}
backend appsrv{
    .host = "172.18.100.68";
    .port = "80";
}
sub vcl_recv{
    if(req.url ~ "(?i)\.php$"){
    set req.backend_hint = appsrv;
    }
    else{
    set req.backend_hint = default;
    }
}</pre>
<p>缓存的负载均衡实现：</p>
<pre>/*在default.vcl中写入：*/
import directors;

backend websrv1{
    .host = "192.168.1.101";
    .port = "80";
}

backend websrv2{
    .host = "192.168.1.102";
    .port = "80";
}

sub vcl_init{
    new websrvs = directors.round_robin();
    websrvs.add_backend(websrv1);
    websrvs.add_backend(websrv2);
}

sub vcl_recv{
    set req.backend_hint = websrvs.backend();
}</pre>
<p>对后端主机做健康检测：</p>
<pre>backend websrv1 {
    .host = "192.168.1.101";
    .port = "80";
    .probe = {
    .url = "/";
    .interval = 1s;
    .window = 8;     //表示最近检测的次数
    .threshold = 5;   //最近检测的次数中成功的次数
    .timeout = 2s;   //探测时的超时时长
    }
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 14:34:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/image/" title="image">image</a>, <a href="https://www.biecuoliao.com/tag/rect/" title="rect">rect</a>, <a href="https://www.biecuoliao.com/tag/and/" title="and">and</a>, <a href="https://www.biecuoliao.com/tag/bin/" title="bin">bin</a>, <a href="https://www.biecuoliao.com/tag/%e8%87%aa%e8%ba%ab/" title="自身">自身</a>, <a href="https://www.biecuoliao.com/tag/%e5%bf%ab%e9%80%9f/" title="快速">快速</a>, <a href="https://www.biecuoliao.com/tag/%e4%ba%8c%e8%bf%9b%e5%88%b6/" title="二进制">二进制</a>, <a href="https://www.biecuoliao.com/tag/srv/" title="srv">srv</a>, <a href="https://www.biecuoliao.com/tag/%e7%bc%93%e5%ad%98%e5%91%bd%e4%b8%ad/" title="缓存命中">缓存命中</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Varnish简介的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38jqgAM.html" rel="bookmark">WEB缓存控制机制与varnish简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在说到缓存varnish前,我们首先来了解下对于web服务缓存到底是什么?它有哪些特点,基础原理是什么? http是web应用协议,通常我们说的一次http事务,不外乎就是客户端请求,服务端响应,通常我们是这样去理解http一次事务的过程:其实对于web服务器来说,一个客户端访问服务端的某资源时,往往客户端的请求没有到达真正提供web服务的服务器上,就被响应了,这是为什么呢?我们知道一个WEB站点在提供对外访问的页面上在一定时间内都不会发生变化,而对于这些不经常变化的资源,访问又特别大的情况,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pe51wM.html" rel="bookmark">Varnish缓存代理简介与配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.varnish原理: 1)Varnish简介: varnish缓存是web应用加速器,同时也作为http反向缓存代理.你可以安装varnish在任何http的前端,同时配置它缓存内容.与传统的 squid 相比,varnish 具有性能更高.速度更快.管理更加方便等诸多优点.有一部分企业已经在生产环境中使用其作为旧版本的squid的替代方案,以在相同的服务器成本下提供更好的缓存效果,Varnish更是作为CDN缓存服务器的可选服务之一. 根据官网的介绍,Varnish的主要特性如下:http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGGAAQM.html" rel="bookmark">Varnish实现Web缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				varnish实现Web缓存 一.varnish简介 Varnish 的作者Poul-Henning Kamp是FreeBSD的内核开发者之一,他认为现在的计算机比起1975年已经复杂许多.在1975年时,储存媒介只有两种:内存与硬盘.但现在计算 机系统的内存除了主存外,还包括了CPU内的L1.L2,甚至有L3快取.硬盘上也有自己的快取装置,因此Squid Cache自行处理物件替换的架构不可能得知这些情况而做到最佳化,但操作系统可以得知这些情况,所以这部份的工作应该交给操作系统处理,这就是 V			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoQzvQ3.html" rel="bookmark">Linux之varnish</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:varnish简介 Varnish是一款高性能的开源HTTP加速器,挪威最大的在线报纸 Verdens Gang 使用3台Varnish代替了原来的12台Squid,性能比以前更好 Varnish 的作者Poul-Henning Kamp是FreeBSD的内核开发者之一,他认为现在的计算机比起1975年已经复杂许多.在1975年时,储存媒介只有两种:内存与硬盘.但现在计算机系统的内存除了主存外,还包括了CPU内的L1.L2,甚至有L3快取.硬盘上也有自己的快取装置,因此Squid Cache			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KaNDY4.html" rel="bookmark">varnish的缓存加速，以及动静分离，负载均衡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个简单的拓扑如上,varnish1 上还同时开了nginx,用来做静态的http,app1和app2 是nginx+fastcgi,这个拓扑主要做的是Discuz!论坛的动静分离,以及app的负载均衡,varnish起到个反向代理和缓存加速的功能. varnish1:192.168.1.151,172.16.0.51 app1:172.16.0.52 app3:172.16.0.54 varnish 简介 varnish的缓存方式: 1.malloc,通过malloc获取内存,简单,速度. 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vEqag0.html" rel="bookmark">缓存服务器varnish概念篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Varnish 简介 Varnish是一款高性能的开源HTTP加速器,挪威最大的在线报纸 Verdens Gang 使用3台Varnish代替了原来的12台Squid,性能比以前更好. Varnish 的作者Poul-Henning Kamp是FreeBSD的内核开发者之一,他认为现在的计算机比起1975年已经复杂许多.在1975年时,储存媒介只有两种:内存与硬盘.但现在计算机系统的内存除了主存外,还包括了CPU内的L1.L2,甚至有L3快取.硬盘上也有自己的快取装置,因此Squid Cac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418OmP3.html" rel="bookmark">varnish 4&period;0 缓存代理配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.varnish原理: 1)Varnish简介: varnish缓存是web应用加速器,同时也作为http反向缓存代理.你可以安装varnish在任何http的前端,同时配置它缓存内容.与传统的 squid 相比,varnish 具有性能更高.速度更快.管理更加方便等诸多优点.有一部分企业已经在生产环境中使用其作为旧版本的squid的替代方案,以在相同的服务器成本下提供更好的缓存效果,Varnish更是作为CDN缓存服务器的可选服务之一. 根据官网的介绍,Varnish的主要特性如下:http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YXexwM.html" rel="bookmark">varnish学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 Varnish简介及特点 Varnish日志 Varnish系统结构 Varnish所支持的算法 VCL介绍 Varnish后端存储 Varnish实战 Varnish简介及特点 Varnish是一款高性能且开源的反向代理服务器和HTTP缓存加速器:在1975年时,储存媒介只有两种:内存与硬盘.但现在计算机系统的内存除了主存外,还包括了CPU内的L1.L2,甚至有L3快取.硬盘上也有自己的快取装置,因此Squid Cache自行处理物件替换的架构不可能得知这些情况而做到最佳化,但操作系统可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPDoxnM.html" rel="bookmark">Linux集群之varnish应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.varnish简介 varnish是一款高性能且开源的反向代理服务器和HTTP加速器,其采用全新的软件设置体系机构,和现的的硬件体系紧密配合,与传递的squid相比,varnish相比,varnish具有性能更高.速度更快.管理更加方便等诸多优点. 二. varnish软件体系架构 varnish主要运行两个进程:Management进程和Child进程. Management进程主要实现应用新的配置.编译VCL.监控varnish.初始化varnish以及提供一个命令行接口等.Manage			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0nlGN4.html" rel="bookmark" class="title">了解OLTP&sol;OLAP</a>
					<div>
						OLTP:联机事务处理,表示事务多,但执行大多较短,并发量大的数据库,如日常的进销存操作等: OLAP: 联机分析处理,表示事务较少,但执行大多较长,并发量较小的数据库,如基于数据仓库的操作: OLT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0x2JB4.html" rel="bookmark" class="title">第五章-習題&lpar;1-11&rpar;待續</a>
					<div>
						5-1 代碼對齊(UVa 1593) 不難,按行讀取,然後stringstream輸入到vector&lt;string&gt;那裏去,算出行最大單詞數,再算出列單詞最大寬度,然後就可以格式化輸出了: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRok83.html" rel="bookmark" class="title">用java构造一个带层次的文件目录遍历器</a>
					<div>
						import java.util.List; import java.io.File; import java.util.ArrayList; public class IteratorUtil {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02brBo0.html" rel="bookmark" class="title">uploadify的碎碎念</a>
					<div>
						uploadify是一个jquery插件,用来实现文件上传的功能. 一般会买一个html5版的. html &lt;input id=&quot;custom_file_upload&quot; ty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdOemM.html" rel="bookmark" class="title">Verilog HDL的不同抽象级别1</a>
					<div>
						用门级结构描述D触发器,实例如下: 由已经设计好的模块构成更高一级的模块,用触发器组成代清零端的4位寄存器代码和实验结果如下: module flop(data,clock,clear,q,qb);i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2xQg3.html" rel="bookmark" class="title">grid安装</a>
					<div>
						oracle grid infrastrucure    GI 提供了自动重启功能和asm功能 1.下载linux.x64_11gR2_grid.ziphttp://www.oracle.com/te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRvP10.html" rel="bookmark" class="title">Sencha Touch 安装</a>
					<div>
						Setup Sencha Touch Content Setup Sencha Touch 1 java environment 2 install ruby (rubyinstaller-1.9.3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7lLw4.html" rel="bookmark" class="title">window下Nodejs的部署</a>
					<div>
						nodejs http://nodejs.org/#download npm node cli.js install npm -gf //可以安装最新版的NPM node cli.js install ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQ1vz3.html" rel="bookmark" class="title">vim可以打开，gvim无法打开</a>
					<div>
						命令行中打开gvim错误,如下: gvim: Fatal IO error 11 (资源暂时不可用) on X server :0. ///////////////////////////////// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZJzy0.html" rel="bookmark" class="title">Python类的&lowbar;&lowbar;getitem&lowbar;&lowbar;和&lowbar;&lowbar;setitem&lowbar;&lowbar;特殊方法</a>
					<div>
						class testsetandget:    kk = {};      def __getitem__(self, key):          return self.kk[key];      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQVKN3.html" rel="bookmark" class="title">《Java从入门到放弃》入门篇：Struts2的常用验证方式</a>
					<div>
						感觉过了一个周末,人都懒得不要不要的,今天就来点简单的内容吧 - -,各位看官如果欲求不满的话,可以自行解决或再去宠幸其他&quot;勃主&quot;··· struts2的验证方式主要有四种方式:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5oE50.html" rel="bookmark" class="title">HTTP状态码搜集</a>
					<div>
						一.1xx消息 这一类型的状态码,代表请求已经接受,需要继续处理. 这类响应是临时响应,只包含状态行和某些可选的响应头信息,并以空行结束. 由于HTTP/1.0协议中没有定义任何1xx状态码,所以除非 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOBnX3.html" rel="bookmark" class="title">PHP 开发 APP 接口 学习笔记与总结 - APP 接口实例 &lbrack;2&rsqb; 首页 APP 接口开发方案 ① 读取数据库方式</a>
					<div>
						方案一:读取数据库方式 从数据库读取信息→封装→生成接口数据 应用场景: 数据时效性比较高的系统 方案二:读取缓存方式 从数据库获取信息(第一次设置缓存或缓存失效时)→封装(第一次设置缓存或缓存失效时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNB6n4.html" rel="bookmark" class="title">css3 景深</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt; &lt;title&gt;景深&lt;/title&gt; &lt;style type=&quot;tex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPR9R4.html" rel="bookmark" class="title">vue使用element-ui的el-input监听不了键盘事件解决</a>
					<div>
						vue使用element-ui的el-input监听不了键盘事件,原因应该是element-ui自身封装了一层div在input标签外面,把原来的事件隐藏了,所以如下代码运行是无响应的: &lt;el ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgl2rr0.html" rel="bookmark" class="title">linux-text-2</a>
					<div>
						移动命令:mv move,移动文件 mv [OPTION]- [-T] SOURCE DEST mv [OPTION]- SOURCE- DIRECTORY mv [OPTION]- -t DIREC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azDzg3.html" rel="bookmark" class="title">commonJS、AMD和CMD之间的区别</a>
					<div>
						JS中的模块规范(CommonJS,AMD,CMD),如果你听过js模块化这个东西,那么你就应该听过或CommonJS或AMD甚至是CMD这些规范咯,我也听过,但之前也真的是听听而已. 现在就看看吧, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47Xwb6M.html" rel="bookmark" class="title">github Permission denied &lpar;publickey&rpar;解决办法</a>
					<div>
						想要玩玩git,参考了网友懒惰之计的一篇Blog&lt;github:如何获取项目源代码 &gt;,按部就班完成了所有的步骤的, 可在测试的时候,遇到了问题,总是报错&quot;github Perm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AaL2Z4.html" rel="bookmark" class="title">这个暑假还有什么比这更嗨的事情了</a>
					<div>
						这个暑假,吖拇带你嗨 吖拇一言不合就开撩 疯狂吖拇携手老师傅.巨匠 2W份九块九钜惠活动等你来领 山药零食+老师傅驴肉+巨匠红薏米芡实茶,9.9元包邮到家 有吃有喝还有肉 吖拇九块九 来一把用舌尖来丈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGJJK3.html" rel="bookmark" class="title">Oracle SQL优化一（常见方法）</a>
					<div>
						1.表访问方式优化: a)普通表优先“Index Lookup 索引扫描”,避免全表扫描 大多数场景下,通过“Index Lookup 索引扫描”要比“Full Table Scan (FTS) 全表 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
